module InvestorAccountAccessor
  def self.included(base)
    base.class_eval do
      belongs_to :member
      has_many :wallets # will be destroyed by bank account cascade destroy
      has_many :bank_accounts, dependent: :destroy
      has_many :investor_state_transitions, dependent: :destroy, class_name: InvestorAccount.investor_state_transition_klass.to_s
    end
  end

  def investments
    wallet_ids = wallets.pluck(:id)
    investment_klass.where(wallet_id: wallet_ids)
  end

  def account_id
    '#' + id.to_s.rjust(6, '0')
  end

  def long_account_id
    'U' + id.to_s.rjust(6, '0')
  end
end