module InvestorAccountDelegation
  module Instance
    def method_missing(method_sym, *args)
      return member.send(method_sym, *args) if member.respond_to?(method_sym)
      super
    end
  end

  module Klass
    def method_missing(method_sym, *args)
      scope = method_sym.to_s.upcase
      if InvestorConstants.constants.include?(scope.to_sym)
        scope_value = const_get scope
        if scope.split(/_/)[0] == 'TIER'
          return where(investor_tier: scope_value)
        end
        if scope.split(/_/)[0] == 'STATUS'
          return where(approval_status: scope_value)
        end
      end
      super
    end
  end
end