class MemberLifecycle
  def self.after_create(member)
    Triggers.send_welcome_email(member)
    Triggers.construct_member(member)
  end

  def self.after_save(member)
    Triggers.record_country_for_reporting(member)
  end

  class Triggers
    def self.send_welcome_email(member)

    end

    def self.construct_member(member)
      investor = member.create_investor_account!
      bank_account = investor.bank_accounts.create!
      investor.wallets.create! bank_account: bank_account,
                               currency: Currency.idr
      investor.wallets.create! bank_account: bank_account,
                               currency: Currency.sgd
      investor.wallets.create! bank_account: bank_account,
                               currency: Currency.myr
      member.create_member_profile!
      member.create_preference!
    end

    def self.record_country_for_reporting(member)
      country = NexusCore::ReportUtils.decode_ip member.last_login_from_ip_address
      if Country[country].present?
        country = Country[country].name
      end
      member.update_column :session_country, country
    end
  end

  module StateMachineTransitionMixin
    # not used
  end
end