module WithdrawalStateMachine
  def self.included(base)
    base.include WithdrawalLifecycle::StateMachineTransitionMixin
    base.class_eval do
      state_machine :status, initial: :pending do
        event :confirm do
          transition [:pending, :cancelled] => :confirmed
        end

        event :cancel do
          transition [:pending] => :cancelled
        end
        after_transition on: :confirm, do: [:save_journal_entry, :send_confirmation_email]
      end
    end
  end
end